<template>
  <div class="flex items-center justify-center gap-0.5 p-1">
    <svn-pro-icon-button
      v-if="selectionItemsRef?.includes('bold')"
      icon="custom:mingcute:bold-line"
      variant="text"
      :color="useTextStates(editorRef)?.isBold ? 'primary' : 'onSurfaceVariant'"
      @click="useTextMenuCommands(editorRef)?.onBold"
    />

    <svn-pro-icon-button
      v-if="selectionItemsRef?.includes('italic')"
      icon="custom:mingcute:italic-line"
      variant="text"
      :color="useTextStates(editorRef)?.isItalic ? 'primary' : 'onSurfaceVariant'"
      @click="useTextMenuCommands(editorRef)?.onItalic"
    />

    <svn-pro-icon-button
      v-if="selectionItemsRef?.includes('underline')"
      icon="custom:mingcute:underline-line"
      variant="text"
      :color="useTextStates(editorRef)?.isUnderline ? 'primary' : 'onSurfaceVariant'"
      @click="useTextMenuCommands(editorRef)?.onUnderline"
    />

    <svn-pro-icon-button
      v-if="selectionItemsRef?.includes('strike')"
      icon="custom:mingcute:strikethrough-line"
      variant="text"
      :color="useTextStates(editorRef)?.isStrike ? 'primary' : 'onSurfaceVariant'"
      @click="useTextMenuCommands(editorRef)?.onStrike"
    />

    <LinkMenu v-if="extensionList?.includes(Link)" :size="size" :editor="editor" :element-target="elementTarget" />

    <ColorPicker v-if="selectionItemsRef?.includes('highlight')" :size="size" :editor="editor" picker-type="color" icon="custom:mingcute:text-color-line" />

    <ColorPicker v-if="selectionItemsRef?.includes('color')" :size="size" :editor="editor" picker-type="highlight" icon="custom:mingcute:pencil-fill"  />

    <TextAlignMenu v-if="selectionItemsRef?.includes('textAlign')" :size="size" :editor="editorRef" />
  </div>
</template>

<script setup>
import LinkMenu from './LinkMenu.vue';
import { Editor } from '@tiptap/vue-3';
import { Link } from '../extensions/index';
import ColorPicker from './ColorPicker.vue';
import { watch, ref, onMounted } from 'vue';
import TextAlignMenu from './TextAlignMenu.vue';
import useTextStates from '../hooks/useTextStates';
import SvnProIconButton from '../../button/SvnProIconButton.vue';
import { useTextMenuCommands } from '../hooks/useTextMenuCommands.js';

const props = defineProps({
  size: { type: String, default: null },
  editor: { type: Editor, default: null },
  selectionItems: { type: Array, default: () => [] },
  extensions: { type: Array, default: () => [] },
  elementTarget: { type: undefined, default: null },
});

onMounted(() => {
  editorRef.value = props.editor
  extensionList.value = props.extensions
  selectionItemsRef.value = props.selectionItems
});

const extensionList = ref([]);
const editorRef = ref(null);
const selectionItemsRef = ref([]);

watch(props, (newValue, oldValue) => {
  if (newValue.editor) {
    editorRef.value = props.editor
  }
  if (newValue.selectionItems) {
    selectionItemsRef.value = props.selectionItems
  }
  if (newValue.extensions) {
    extensionList.value = props.extensions
  }
});
</script>